
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>WCF技术剖析之二：再谈IIS与ASP.NET管道 / iVAN</title>

    <meta name="description" content="WCF技术剖析之二：再谈IIS与ASP.NET管道 IIS 5.x与ASP.NET 我们先来看看IIS 5.x是如何处理基于ASP.NET资源(比如.aspx,.asmx等)请求的,整个过程基本上可以通过图1体现. IIS 5.x运行在进程InetInfo.exe中,在该进程中一个最重要的服务就是名为World Wide Web Publishing Service(简称W3SVC)的Windows Service.W3SVC的主要功能包括HTTP请求的监听.工作进程的管理以及配置管理(通过从Metabase中加载相关配置信息)等. 当检测到某个">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">WCF技术剖析之二：再谈IIS与ASP.NET管道</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>IIS 5.x与ASP.NET</p>
<p>我们先来看看IIS 5.x是如何处理基于ASP.NET资源（比如.aspx,.asmx等）请求的，整个过程基本上可以通过图1体现。</p>
<p>IIS 5.x运行在进程InetInfo.exe中，在该进程中一个最重要的服务就是名为World Wide Web Publishing Service（简称W3SVC）的Windows Service。W3SVC的主要功能包括HTTP请求的监听、工作进程的管理以及配置管理（通过从Metabase中加载相关配置信息）等。</p>
<p>当检测到某个HTTP Request后，先根据扩展名判断请求的是否是静态资源（比如.html,.img,.txt,.xml等），如果是则直接将文件内容以HTTP Response的形式返回。如果是动态资源（比如.aspx,asp,php等等），则通过扩展名从IIS的脚本影射（Script Map）找到相应的ISAPI Dll。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2g0Lm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMTI0NjFLMkotMC5qcGc=.jpg"></p>
<p>图1 IIS 5.x与ASP.NET</p>
<p>ISAPI是Internet服务器API（Internet Server Application Programming Interface）的缩写，是一套本地的（Native）Win32 API，具有较高的执行性能,是IIS和其他动态Web应用或者平台之间的纽带。比如ASP ISAPI桥接IIS与ASP，而ASP.NET ISAPI则连接着IIS与ASP.NET。ISPAI定义在一个Dll中，ASP.NET ISAPI对应的Dll为Aspnet_isapi.dll,你可以在目录“%windir%\Microsoft.NET\Framework\{version no}\”中找到该Dll。</p>
<p>ISAPI支持ISAPI扩展（ISAPI Extension）和ISAPI筛选（ISAPI Filter），前者是真正处理HTTP请求的接口，后者则可以在HTTP请求真正被处理之前查看、修改、转发或者拒绝请求，比如IIS可以利用ISAPI筛选进行请求的验证（Authentication）。</p>
<p>如果我们请求的是一个基于ASP.NET的资源类型，比如：.aspx Web Page、 .asmx Web Service或者.svc WCF Service等，Aspnet_isapi.dll会被加载，ASP.NET ISAPI扩展会创建ASP.NET的工作进程（如果该进程尚未启动），对于IIS 5.x来说，该工作进程为aspnet.exe。IIS进程与工作进程之间通过命名管道（Named Pipes）进程通信，以获得最好的性能。</p>
<p>在工作进程初始化过程中，.NET 运行时（CLR）被加载，从而构建了一个托管的环境。对于某个Web应用的初次请求，CLR会为其创建一个AppDomain。在此AppDomain中，HTTP运行时（HTTP Runtime）被加载并用以创建相应的应用。对于寄宿于IIS 5.x的所有Web 应用都运行在同一个进程（工作进程Aspnet_wp.exe）的不同AppDomain中。</p>
<p>IIS 6与ASP.NET</p>
<p>通过上面的介绍，我们可以看出IIS 5.x至少存在着如下两个方面的不足：</p>
<p>ISAPI Dll被加载到InetInfo.exe进程中，它和工作进程之间是一种典型的跨进程通信方式，尽管采用性能最好的命名管道，但是仍然会带来性能的瓶颈；</p>
<p>所有的ASP.NET应用，运行在相同的进程（aspnet_wp.exe）中的不同的应用程序域（AppDomain）中，基于应用程序域的隔离级别不能从根本上解决一个应用程序对另一个程序的影响，在更多的时候，我们需要不同的Web应用运行在不同的进程中。</p>
<p>在IIS 6.0中，为了解决第一个问题，ISAPI.dll被直接加载到工作进程中。为了解决第2个问题，引入了应用程序池（Application Pool）的机制。我们可以为一个或者多个Web应用创建应用程序池，每一个应用程序池对应一个独立的工作进程，从而为运行在不同应用程序池中的Web应用提供基于进程的隔离级别。IIS 6.0的工作进程名称为w3wp.exe。</p>
<p>当然，除了上面两点改进之外，IIS 6.0还有其他一些值得称道的地方，其中最重要的一点就是创建了一个新的HTTP监听器：HTTP协议栈（HTTP Protocol Stack，HTTP.SYS）。HTTP.SYS运行在Windows的内核模式（Kernel Mode）下，作为驱动程序而存在。它是Windows 2003的TCP/IP网络子系统的一部分，从结构上，它属于TCP之上的一个网络驱动程序。严格地说，HTTP.SYS已经不属于IIS的范畴了，所以HTTP.SYS的配置信息并不保存在IIS的元数据库（Metabase），而是定义在注册表中。HTTP.SYS的注册表项位于下面的路径中：HKEY_LOCAL_MACHINE/SYSTEM/CurrentControlSet/Services/HTTP。HTTP.SYS能够带来如下的好处：</p>
<p>持续监听：由于HTTP.SYS是一个网络驱动程序，始终处于运行状态，对于用户的HTTP请求，能够及时作出反应；</p>
<p>更好的稳定性：HTTP.SYS运行在操作系统内核模式下，并不执行任何用户代码，所以其本身不会受到Web应用、工作进程和IIS进程的影响；</p>
<p>内核模式下数据缓存：如果某个资源被频繁请求，HTTP.SYS会把响应的内容进行缓存，缓存的内容可以直接响应后续的请求。由于这是基于内核模式的缓存，不存在内核模式和用户模式的切换，响应速度将得到极大的改进。</p>
<p>图2体现了IIS的结构和处理HTTP请求的流程。从中可以看出，与IIS 5.x不同，W3SVC从InetInfo.exe进程脱离出来（对于IIS6.0来说，InetInfo.exe基本上可以看作单纯的IIS管理进程），运行在另一个进程SvcHost.exe中。不过W3SVC的基本功能并没有发生变化，只是在功能的实现上作了相应的改进。与IIS 5.x一样，元数据库（Metabase）依然存在于InetInfo.exe进程中。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2g0Lm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMTI0NjFJM1AtMS5qcGc=.jpg"></p>
<p>图2 IIS 6与ASP.NET</p>
<p>当HTTP.SYS监听到用户的HTTP请求后，将其分发给W3SVC。W3SVC解析出请求的URL，并根据从Metabase获取的URL与Web应用之间的映射关系得到目标应用，并进一步得到目标应用运行的应用程序池或者工作进程。如果工作进程不存在（尚未创建或者被回收），则为该请求创建新的工作进程，工作进程的这种创建方式被称为请求式创建。在工作进程的初始化过程中，相应的ISAPI.dll被加载，对于ASP.NET应用来说，被加载的ISAPI.dll为Aspnet_ispai.dll。ASP.NET ISAPI再负责进行CLR的加载、AppDomain创建、Web Application的初始化等。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 05:24:24</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/http/" title="http">http</a>, <a href="https://www.iamivan.net/tag/%e5%b7%a5%e4%bd%9c/" title="工作">工作</a>, <a href="https://www.iamivan.net/tag/%e8%bf%9b%e7%a8%8b/" title="进程">进程</a>, <a href="https://www.iamivan.net/tag/iis/" title="iis">iis</a>, <a href="https://www.iamivan.net/tag/isapi/" title="ISAPI">ISAPI</a>, <a href="https://www.iamivan.net/tag/iis%e8%af%b7%e6%b1%82/" title="iis请求">iis请求</a>, <a href="https://www.iamivan.net/tag/%e5%b7%a5%e4%bd%9c%e8%bf%9b%e7%a8%8b/" title="工作进程">工作进程</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>WCF技术剖析之二：再谈IIS与ASP.NET管道的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmj7Jwz.html" rel="bookmark">艾伟&lowbar;转载：&lbrack;原创&rsqb;再谈IIS与ASP&period;NET管道</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在2007年9月份,我曾经写了三篇详细介绍IIS架构和ASP.NET运行时管道的文章,深入介绍了IIS 5.x与IIS 6.0HTTP请求的监听与分发机制,以及ASP.NET运行时管道对HTTP请求的处理流程: [原创]ASP.NET Process Model之一:IIS 和 ASP.NET ISAPI[原创]ASP.NET Process Model之二:ASP.NET Http Runtime Pipeline - Part I[原创]ASP.NET Process Model之二:ASP			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP28kZb.html" rel="bookmark">艾伟：&lbrack;原创&rsqb;再谈IIS与ASP&period;NET管道</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在2007年9月份,我曾经写了三篇详细介绍IIS架构和ASP.NET运行时管道的文章,深入介绍了IIS 5.x与IIS 6.0HTTP请求的监听与分发机制,以及ASP.NET运行时管道对HTTP请求的处理流程: [原创]ASP.NET Process Model之一:IIS 和 ASP.NET ISAPI[原创]ASP.NET Process Model之二:ASP.NET Http Runtime Pipeline - Part I[原创]ASP.NET Process Model之二:ASP			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z46QD9M.html" rel="bookmark">&lbrack;原创&rsqb;再谈IIS与ASP&period;NET管道</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在2007年9月份,我曾经写了三篇详细介绍IIS架构和ASP.NET运行时管道的文章,深入介绍了IIS 5.x与IIS 6.0HTTP请求的监听与分发机制,以及ASP.NET运行时管道对HTTP请求的处理流程: [原创]ASP.NET Process Model之一:IIS 和 ASP.NET ISAPI[原创]ASP.NET Process Model之二:ASP.NET Http Runtime Pipeline - Part I[原创]ASP.NET Process Model之二:ASP			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pk2mn1M.html" rel="bookmark">WCF技术剖析之二十七&colon; 如何将一个服务发布成WSDL</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[基于WS-MEX的实现](提供模拟程序) 通过&lt;如何将一个服务发布成WSDL[编程篇]&gt;的介绍我们知道了如何可以通过编程或者配置的方式将ServiceMetadataBehavior这样一个服务形式应用到相应的服务上面,从而实现基于HTTP-GET或者WS-MEX的元数据发布机制.那么在WCF内部具体的实现原理又是怎样的呢?相信很多人对此都心存好奇,本篇文章的内容将围绕着这个主题展开. 一. 从WCF分发体系谈起 如果读者想对WCF内部的元数据发布机制的实现原理有一个全面而深入的了解,必须对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pm6Xw3z.html" rel="bookmark">WCF技术剖析之二十七&colon; 如何将一个服务发布成WSDL&lbrack;基于WS-MEX的实现&rsqb;（提供模拟程序）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				通过&lt;如何将一个服务发布成WSDL[编程篇]&gt;的介绍我们知道了如何可以通过编程或者配置的方式将ServiceMetadataBehavior这样一个服务形式应用到相应的服务上面,从而实现基于HTTP-GET或者WS-MEX的元数据发布机制.那么在WCF内部具体的实现原理又是怎样的呢?相信很多人对此都心存好奇,本篇文章的内容将围绕着这个主题展开. 一. 从WCF分发体系谈起 如果读者想对WCF内部的元数据发布机制的实现原理有一个全面而深入的了解,必须对WCF服务端的分发体系有一个清晰的认识.在这			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgKJq6M.html" rel="bookmark">WCF技术剖析之二十六&colon;如何导出WCF服务的元数据&lpar;Metadata&rpar;&lbrack;扩展篇&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				通过&lt;实现篇&gt;对WSDL元素和终结点三要素的之间的匹配关系的介绍,我们知道了WSDL的Binding元素来源于终结点的绑定对象,那么这些基于Binding的元数据以及相应的策略断言是如何被写入WSDL的呢?WSDL导出扩展(WSDL Export Extension)和策略导出扩展(Policy Export Extension)就是为此设计的. 一.WSDL导出扩展(WSDL Export Extension) 终结点的绑定本质上就是相关的绑定元素(BindingElement)的有序组合(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1lNrdb.html" rel="bookmark">WCF技术剖析之二十三：服务实例（Service Instance）生命周期如何控制&lbrack;下篇&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在[第2篇]中,我们深入剖析了单调(PerCall)模式下WCF对服务实例生命周期的控制,现在我们来讨轮另一种极端的服务实例上下文模式:单例(Single)模式.在单例模式下,WCF通过创建一个唯一的服务实例来处理所有的客户端服务调用请求.这是一个极端的服务实例激活方式,由于服务实例的唯一性,所有客户端每次调用的状态能够被保存下来,但是当前的状态是所有客户端作用于服务实例的结果,而不能反映出具体某个客户端多次调用后的状态.WCF是一个典型的多线程的通信框架,对并发的服务调用请求是最基本的能力和要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo6ayvz.html" rel="bookmark">WCF技术剖析之二十一：WCF基本异常处理模式&lbrack;下篇&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				从FaultContractAttribute的定义我们可以看出,该特性可以在同一个目标对象上面多次应用(AllowMultiple = true).这也很好理解:对于同一个服务操作,可能具有不同的异常场景,在不同的情况下,需要抛出不同的异常. 1: [AttributeUsage(AttributeTargets.Method, AllowMultiple = true, Inherited = false)] 2: public sealed class FaultContractAttri			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlR0laz.html" rel="bookmark">WCF技术剖析之二十五&colon;元数据（Metadata）架构体系全景展现&lbrack;WS标准篇&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				元数据实际上是服务终结点的描述,终结点由地址(Address).绑定(Binding)和契约(Contract)经典的ABC三要素组成.认真阅读过&lt;WCF技术剖析(卷1)&gt;的读者相对会对这三要素的本质有一个深刻的认识:地址决定了服务的位置并实现相应的寻址机制:契约描述了消息交换模式(Message Exchange Pattern: MEP)以及消息的结构(Schema):绑定则通过创建信道栈实现对消息的编码.传输和基于某些特殊的功能(比如实现事务.可靠传输以及基于消息的安全)对消息作出的处理			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpm7xlb.html" rel="bookmark" class="title">Windows Phone的独立存储简介</a>
					<div>
						什么是独立存储 独立存储(isolatedstorage)这个东西 是首先在SilverLight使用的(好 吧我是因为wp才认识独立存储的) 要说明什么是独立存储 首先就说什么是独立(isolate ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgO6BM.html" rel="bookmark" class="title">未来的网站策划五大趋势&amp;amp&semi;nbsp&semi;思路要清晰合理</a>
					<div>
						网站策划是成功网站平台建设成败的关键内容之一.在中国真正普及全职的网站策划人员严格讲是2002年,在之前更多是由技术性人才(软件项目经理.网站美工等)担任此项职位,随着中国互联网环境转晴,网站的高竞争 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjl9mp.html" rel="bookmark" class="title">CSS属性&lpar;容器属性&rpar;</a>
					<div>
						css 本节我将向您介绍填充距属性.我们先来看一下填充距的属性列表: 首先我们得先了解什么叫填充距,它与边距有什么差别呢?填充距指的是文本边框与文本之间的距离. 这样讲是不是有些难懂,由于填充距属性与 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwa8qz.html" rel="bookmark" class="title">MySQL主从同步部署总结</a>
					<div>
						操作环境 主:192.168.1.124 从:192.168.1.125 mysql-5.0.56.tar.gz .centos5.2 数据库1:/data/3306/  数据库2:/data/330 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKqDWp.html" rel="bookmark" class="title">java菜单实现</a>
					<div>
						直接在程序片中安放一个菜单是不可能的(Java 1.0,Java1.1和Swing库不允许),因为它们是针对应用程序的.继续,如果您不相信我并且确定在程序片中可以合理地拥有菜单,那么您可以去试验一下. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLDO3b.html" rel="bookmark" class="title">我是这么利用数据：公共汽车的故事</a>
					<div>
						自从买了车之后很少坐公交车了,不过对公交车的感悟由来已久,这些个每天奔驰在城市的各条道路上的 大家伙,年复一年,日复一日,没有明确的说要去载谁上路,但不影响他们总是按时按点从起点出发,顺顺利 利的到达 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRy6Q3b.html" rel="bookmark" class="title">Photoshop打造柔和的金色花朵背景婚片</a>
					<div>
						金色是种比较容易调整的颜色,不过这种颜色比较鲜丽,调好后还需要把图片整体调暗并适当柔化处理,来增强画面的层次感.局部可以按照自己的喜爱增加一些补色. 原图 &lt;点小图查看大图&gt; 最终效果1. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBQvqz.html" rel="bookmark" class="title">Apache的prefork模式和worker模式该户</a>
					<div>
						prefork模式 这个多路处理模块(MPM)实现了一个非线程型的.预派生的web服务器,它的工作方式类似于Apache 1.3.它适合于没有线程安全库,需要避免线程兼容性问题的系统.它是要求将每个请 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3dZxp.html" rel="bookmark" class="title">使用jquery实现IE下按backspace相当于返回操作</a>
					<div>
						 后退键在各浏览器下默认为点击了一下后退按钮,下面为大家介绍下如何实现实现IE下按backspace相当于返回操作,需要的朋友可以参考下 其实说禁用也不是完全禁用,后退键在各浏览器下默认为点击了一下后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7JNVb.html" rel="bookmark" class="title">document&period;compatMode的CSS1compat使用介绍</a>
					<div>
						 这篇文章主要介绍了document.compatMode的CSS1compat使用,需要的朋友可以参考下 document.compatMode    BackCompat:标准兼容模式关闭.浏览器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqrVxb.html" rel="bookmark" class="title">ASP&period;NET 页面之间传递值方式优缺点比较&lowbar;实用技巧</a>
					<div>
						本题考查面试者对ASP.NET中多页面传值的理解是否全面.因为ASP.NET的页面表单提交到自身,完成回传的功能,所以默认情况下不能使用POST方式进行多页面传值.关于这些传值方式的分析如下所示.1． ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVV31b.html" rel="bookmark" class="title">select-为什么onsubmit在审核地址的时候就失效了呢？</a>
					<div>
						问题描述 为什么onsubmit在审核地址的时候就失效了呢? 其他的账号密码都可以拦住,但是地址不管有没有选,只要提交就可以跳到servlet,而且只要账号密码都填了,就算onsubmit里面chec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6YnOb.html" rel="bookmark" class="title">SQL应用与开发：（六）函数和表达式的使用</a>
					<div>
						在前面几篇博文中已经介绍了许多与表有关的操作.为了演示SQL的不同组件,前面讨论了创建表.基于表的视图.查询表.修改表的数据以及表的关系等.在接下来的博文中将继续介绍SQL中的函数和表达式的使用,重点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boR1vgz.html" rel="bookmark" class="title">opengl-文件操作，我将文件操作部分的代码放在，myDisplay函数内部就没有问题了。。这是为什么</a>
					<div>
						问题描述 文件操作,我将文件操作部分的代码放在,myDisplay函数内部就没有问题了..这是为什么 F:WORKopengl test tempdashBoard.cpp(8) : error C2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdE3BAz.html" rel="bookmark" class="title">Scrapy 核心架构 流程 （三）</a>
					<div>
						一. 核心架构关于核心架构,在官方文档中阐述的非常清晰,地址:http://doc.scrapy.org/en/latest/topics/architecture.html.英文有障碍可查看中文翻译 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBWwoM.html" rel="bookmark" class="title">还不到1岁的钉钉，如何通过阿里云为千万企业插上翅膀</a>
					<div>
						1月14日,在阿里巴巴生态峰会上,钉钉.阿里云.阿里巴巴国际站联合第三方外贸管理软件,推出了面向中国外贸中小企业的&quot;阿里钉钉外贸工作平台&quot;版本的免费试用,这是钉钉力图打造大平台的重 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBW4KM.html" rel="bookmark" class="title">frame-Java 自定义类继承Frame问题</a>
					<div>
						问题描述 Java 自定义类继承Frame问题 我想问下自定义类继承Frame类后,是不是自定义类本身就是一个Frame,比如 class MyFrame exdents Frame{ Public  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RZmmz.html" rel="bookmark" class="title">请问c语言中&period;h文件如何从cpp中提取或者是撰写</a>
					<div>
						问题描述 请问c语言中.h文件如何从cpp中提取或者是撰写 大一的课程设计的一个小程序,老师要求有.h的头文件,但是我只有一个cpp文件,请问这个.h文件如何写? 解决方案 如果你说你手头上有一个简单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0kYlM.html" rel="bookmark" class="title">Windows Phone 8初学者开发&mdash;第8部分：理解编译和部署</a>
					<div>
						原文 Windows Phone 8初学者开发-第8部分:理解编译和部署 第8部分:理解编译和部署 原文地址: http://channel9.msdn.com/Series/Windows-Phon ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLyR5p.html" rel="bookmark" class="title">MySQL内核月报 2015&period;03-MySQL &CenterDot; 答疑释惑&CenterDot; 并发Replace into导致的死锁分析</a>
					<div>
						测试版本:MySQL5.6.23 测试表: 背景 Replace into操作可以算是比较常用的操作类型之一,当我们不确定即将插入的记录是否存在唯一性冲突时,可以通过Replace into的方式让M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjaxKM.html" rel="bookmark" class="title">oracle-如何将A表中的字段一的值赋值给B表中的字段一</a>
					<div>
						问题描述 如何将A表中的字段一的值赋值给B表中的字段一 这是我编写的的 UPDATE poc.zjqx p SET (p.as_of_date) = ( SELECT (o.as_of_date) F ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7jxkz.html" rel="bookmark" class="title">在 Linux 终端中自定义 Bash 配色和提示内容</a>
					<div>
						现今,大多数(如果不是全部的话)现代 Linux 发行版的默认 shell 都是 Bash.然而,你可能已经注意到这样一个现象,在各个发行版中,其终端配色和提示内容都各不相同. 如果你一直都在考虑,或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0745p.html" rel="bookmark" class="title">利用IBM PureApplication System实现业务关键工作负载</a>
					<div>
						PureApplication System 提供了一个灵活的平台来运行云http://www.aliyun.com/zixun/aggregation/13748.html&quot;&gt;基础架 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgNXZM.html" rel="bookmark" class="title">&lbrack;译&rsqb; React 在服务端渲染的实现</a>
					<div>
						本文讲的是[译] React 在服务端渲染的实现, 原文地址:Server-Side React Rendering 原文作者:Roger Jin 译文出自:掘金翻译计划 本文永久链接:github. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4eQrqb.html" rel="bookmark" class="title">由于第一季度利润未及分析师预期，同时遭受四家投资银行下调评级</a>
					<div>
						据国外媒体报道,由于第一季度利润未及分析师预期,同时遭受四家投资银行下调评级,新浪股价本周累计下跌15%,创该公司2008年12月以来单周跌幅之最. 周五在纽约证券交易所,新浪股价下跌6.27美元,报 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBk6ZaM.html" rel="bookmark" class="title">广州采血点涉嫌倒卖献血证3000元5天即可得</a>
					<div>
						据中国之声&lt;新闻纵横&gt;报道,拥有一本小小的&lt;无偿献血证&gt;,不仅是一种荣誉,还可以在需要的时候享受免费用血.可是有人不献血也能弄到货真价实的&lt;无偿献血证&gt;,这是发生在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6G5OXp.html" rel="bookmark" class="title">Java中BEAN与EJB的区别浅析&lowbar;java</a>
					<div>
						Java Bean 是可复用的组件,对Java Bean并没有严格的规范,理论上讲,任何一个Java类都可以是一个Bean.但通常情况下,由于Java Bean是被容器所创建(如Tomcat)的,所以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKQyKM.html" rel="bookmark" class="title">判断js对象是否拥有某一个属性的js代码&lowbar;javascript技巧</a>
					<div>
						复制代码 代码如下: var obj = {name:'jack'}; obj.hasOwnProperty('name'); // --&gt; true obj.hasOwnProperty('t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2V0OM.html" rel="bookmark" class="title">js把字符串编码转换为Unicode编码</a>
					<div>
						Javascript 内置了转换函数:String.fromCharCodeAt().string.charCodeAt()来进行字符串与编码之间的转换. 所以我们要进行字符串的转换其实很简单,直接用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWenkz.html" rel="bookmark" class="title">搜索引擎排名的重要性</a>
					<div>
						搜索引擎排名并不是无价值的游戏,而是整个网络营销中最为重要的组成部分,是针对搜索引擎的特性(地理,语言,用户群)等进行的一种广告投资行为.凡是使用互联网的人最终都要使用搜索引擎,因此搜索引擎排名是网络 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
